<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfTaxaDETRANDTO ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfTaxaDETRANDTO
 * @subpackage Arrays
 */
class ArrayOfTaxaDETRANDTO extends AbstractStructArrayBase
{
    /**
     * The TaxaDETRANDTO
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\TaxaDETRANDTO[]
     */
    public $TaxaDETRANDTO;
    /**
     * Constructor method for ArrayOfTaxaDETRANDTO
     * @uses ArrayOfTaxaDETRANDTO::setTaxaDETRANDTO()
     * @param \StructType\TaxaDETRANDTO[] $taxaDETRANDTO
     */
    public function __construct(array $taxaDETRANDTO = array())
    {
        $this
            ->setTaxaDETRANDTO($taxaDETRANDTO);
    }
    /**
     * Get TaxaDETRANDTO value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\TaxaDETRANDTO[]|null
     */
    public function getTaxaDETRANDTO()
    {
        return isset($this->TaxaDETRANDTO) ? $this->TaxaDETRANDTO : null;
    }
    /**
     * This method is responsible for validating the values passed to the setTaxaDETRANDTO method
     * This method is willingly generated in order to preserve the one-line inline validation within the setTaxaDETRANDTO method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateTaxaDETRANDTOForArrayConstraintsFromSetTaxaDETRANDTO(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfTaxaDETRANDTOTaxaDETRANDTOItem) {
            // validation for constraint: itemType
            if (!$arrayOfTaxaDETRANDTOTaxaDETRANDTOItem instanceof \StructType\TaxaDETRANDTO) {
                $invalidValues[] = is_object($arrayOfTaxaDETRANDTOTaxaDETRANDTOItem) ? get_class($arrayOfTaxaDETRANDTOTaxaDETRANDTOItem) : sprintf('%s(%s)', gettype($arrayOfTaxaDETRANDTOTaxaDETRANDTOItem), var_export($arrayOfTaxaDETRANDTOTaxaDETRANDTOItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The TaxaDETRANDTO property can only contain items of type \StructType\TaxaDETRANDTO, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set TaxaDETRANDTO value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\TaxaDETRANDTO[] $taxaDETRANDTO
     * @return \ArrayType\ArrayOfTaxaDETRANDTO
     */
    public function setTaxaDETRANDTO(array $taxaDETRANDTO = array())
    {
        // validation for constraint: array
        if ('' !== ($taxaDETRANDTOArrayErrorMessage = self::validateTaxaDETRANDTOForArrayConstraintsFromSetTaxaDETRANDTO($taxaDETRANDTO))) {
            throw new \InvalidArgumentException($taxaDETRANDTOArrayErrorMessage, __LINE__);
        }
        if (is_null($taxaDETRANDTO) || (is_array($taxaDETRANDTO) && empty($taxaDETRANDTO))) {
            unset($this->TaxaDETRANDTO);
        } else {
            $this->TaxaDETRANDTO = $taxaDETRANDTO;
        }
        return $this;
    }
    /**
     * Add item to TaxaDETRANDTO value
     * @throws \InvalidArgumentException
     * @param \StructType\TaxaDETRANDTO $item
     * @return \ArrayType\ArrayOfTaxaDETRANDTO
     */
    public function addToTaxaDETRANDTO(\StructType\TaxaDETRANDTO $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\TaxaDETRANDTO) {
            throw new \InvalidArgumentException(sprintf('The TaxaDETRANDTO property can only contain items of type \StructType\TaxaDETRANDTO, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->TaxaDETRANDTO[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\TaxaDETRANDTO|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\TaxaDETRANDTO|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\TaxaDETRANDTO|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\TaxaDETRANDTO|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\TaxaDETRANDTO|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string TaxaDETRANDTO
     */
    public function getAttributeName()
    {
        return 'TaxaDETRANDTO';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfTaxaDETRANDTO
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
