<?php
/**
 * Class which returns the class map definition
 * @package
 */
class ClassMap
{
    /**
     * Returns the mapping between the WSDL Structs and generated Structs' classes
     * This array is sent to the \SoapClient when calling the WS
     * @return string[]
     */
    final public static function get()
    {
        return array(
            'RetornoIPVA' => '\\StructType\\RetornoIPVA',
            'DebitoBase' => '\\StructType\\DebitoBase',
            'Veiculo' => '\\StructType\\Veiculo',
            'Licenciamento' => '\\StructType\\Licenciamento',
            'ArrayOfDPVAT' => '\\ArrayType\\ArrayOfDPVAT',
            'DPVAT' => '\\StructType\\DPVAT',
            'ArrayOfIPVA' => '\\ArrayType\\ArrayOfIPVA',
            'IPVA' => '\\StructType\\IPVA',
            'ItemPagamento' => '\\StructType\\ItemPagamento',
            'ArrayOfMulta' => '\\ArrayType\\ArrayOfMulta',
            'Multa' => '\\StructType\\Multa',
            'ItemPagamentoMulta' => '\\StructType\\ItemPagamentoMulta',
            'Transferencia' => '\\StructType\\Transferencia',
            'RetornoMultaRENAINF' => '\\StructType\\RetornoMultaRENAINF',
            'ArrayOfMultaRENAINF' => '\\ArrayType\\ArrayOfMultaRENAINF',
            'MultaRENAINF' => '\\StructType\\MultaRENAINF',
            'Debito' => '\\StructType\\Debito',
            'RetornoDPVAT' => '\\StructType\\RetornoDPVAT',
            'RetornoMulta' => '\\StructType\\RetornoMulta',
            'RetornoPagamento' => '\\StructType\\RetornoPagamento',
            'PrimeiroRegistro' => '\\StructType\\PrimeiroRegistro',
            'DPVATPrimeiroRegistro' => '\\StructType\\DPVATPrimeiroRegistro',
            'TaxaDETRANDTO' => '\\StructType\\TaxaDETRANDTO',
            'ArrayOfReciboImprimirDTO' => '\\ArrayType\\ArrayOfReciboImprimirDTO',
            'ReciboImprimirDTO' => '\\StructType\\ReciboImprimirDTO',
            'ConsultaTaxasDETRANDTO' => '\\StructType\\ConsultaTaxasDETRANDTO',
            'ArrayOfTaxaDETRANDTO' => '\\ArrayType\\ArrayOfTaxaDETRANDTO',
            'ArrayOfBuscarRecibosDTO' => '\\ArrayType\\ArrayOfBuscarRecibosDTO',
            'BuscarRecibosDTO' => '\\StructType\\BuscarRecibosDTO',
            'PagaIPVA' => '\\StructType\\PagaIPVA',
            'PagaIPVAResponse' => '\\StructType\\PagaIPVAResponse',
            'PagaDPVAT' => '\\StructType\\PagaDPVAT',
            'PagaDPVATResponse' => '\\StructType\\PagaDPVATResponse',
            'PagaMultas' => '\\StructType\\PagaMultas',
            'PagaMultasResponse' => '\\StructType\\PagaMultasResponse',
            'PagaMultasRENAINF' => '\\StructType\\PagaMultasRENAINF',
            'PagaMultasRENAINFResponse' => '\\StructType\\PagaMultasRENAINFResponse',
            'PagaTransferencia' => '\\StructType\\PagaTransferencia',
            'PagaTransferenciaResponse' => '\\StructType\\PagaTransferenciaResponse',
            'PagaLicenciamento' => '\\StructType\\PagaLicenciamento',
            'PagaLicenciamentoResponse' => '\\StructType\\PagaLicenciamentoResponse',
            'PagaPrimeiroRegistro' => '\\StructType\\PagaPrimeiroRegistro',
            'PagaPrimeiroRegistroResponse' => '\\StructType\\PagaPrimeiroRegistroResponse',
            'PagaDPVATPrimeiroRegistro' => '\\StructType\\PagaDPVATPrimeiroRegistro',
            'PagaDPVATPrimeiroRegistroResponse' => '\\StructType\\PagaDPVATPrimeiroRegistroResponse',
            'PagaDebitos' => '\\StructType\\PagaDebitos',
            'PagaDebitosResponse' => '\\StructType\\PagaDebitosResponse',
            'PagaTaxasDETRAN' => '\\StructType\\PagaTaxasDETRAN',
            'PagaTaxasDETRANResponse' => '\\StructType\\PagaTaxasDETRANResponse',
            'URLRecibos' => '\\StructType\\URLRecibos',
            'URLRecibosResponse' => '\\StructType\\URLRecibosResponse',
            'ConsultaDPVAT' => '\\StructType\\ConsultaDPVAT',
            'ConsultaDPVATResponse' => '\\StructType\\ConsultaDPVATResponse',
            'ConsultaIPVA' => '\\StructType\\ConsultaIPVA',
            'ConsultaIPVAResponse' => '\\StructType\\ConsultaIPVAResponse',
            'ConsultaMultas' => '\\StructType\\ConsultaMultas',
            'ConsultaMultasResponse' => '\\StructType\\ConsultaMultasResponse',
            'ConsultaMultasRENAINF' => '\\StructType\\ConsultaMultasRENAINF',
            'ConsultaMultasRENAINFResponse' => '\\StructType\\ConsultaMultasRENAINFResponse',
            'ConsultaTransferencia' => '\\StructType\\ConsultaTransferencia',
            'ConsultaTransferenciaResponse' => '\\StructType\\ConsultaTransferenciaResponse',
            'ConsultaTransferenciaComLicenciamento' => '\\StructType\\ConsultaTransferenciaComLicenciamento',
            'ConsultaTransferenciaComLicenciamentoResponse' => '\\StructType\\ConsultaTransferenciaComLicenciamentoResponse',
            'ConsultaLicenciamento' => '\\StructType\\ConsultaLicenciamento',
            'ConsultaLicenciamentoResponse' => '\\StructType\\ConsultaLicenciamentoResponse',
            'ConsultaDebitos' => '\\StructType\\ConsultaDebitos',
            'ConsultaDebitosResponse' => '\\StructType\\ConsultaDebitosResponse',
            'ConsultaPrimeiroRegistro' => '\\StructType\\ConsultaPrimeiroRegistro',
            'ConsultaPrimeiroRegistroResponse' => '\\StructType\\ConsultaPrimeiroRegistroResponse',
            'ConsultaTaxasDETRAN' => '\\StructType\\ConsultaTaxasDETRAN',
            'ConsultaTaxasDETRANResponse' => '\\StructType\\ConsultaTaxasDETRANResponse',
            'BuscarRecibos' => '\\StructType\\BuscarRecibos',
            'BuscarRecibosResponse' => '\\StructType\\BuscarRecibosResponse',
        );
    }
}
