<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ConsultaTransferencia StructType
 * @subpackage Structs
 */
class ConsultaTransferencia extends AbstractStructBase
{
    /**
     * The Identificador
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Identificador;
    /**
     * The Chave
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Chave;
    /**
     * The trocaCheque
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var bool
     */
    public $trocaCheque;
    /**
     * Constructor method for ConsultaTransferencia
     * @uses ConsultaTransferencia::setIdentificador()
     * @uses ConsultaTransferencia::setChave()
     * @uses ConsultaTransferencia::setTrocaCheque()
     * @param string $identificador
     * @param string $chave
     * @param bool $trocaCheque
     */
    public function __construct($identificador = null, $chave = null, $trocaCheque = null)
    {
        $this
            ->setIdentificador($identificador)
            ->setChave($chave)
            ->setTrocaCheque($trocaCheque);
    }
    /**
     * Get Identificador value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getIdentificador()
    {
        return isset($this->Identificador) ? $this->Identificador : null;
    }
    /**
     * Set Identificador value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $identificador
     * @return \StructType\ConsultaTransferencia
     */
    public function setIdentificador($identificador = null)
    {
        // validation for constraint: string
        if (!is_null($identificador) && !is_string($identificador)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($identificador, true), gettype($identificador)), __LINE__);
        }
        if (is_null($identificador) || (is_array($identificador) && empty($identificador))) {
            unset($this->Identificador);
        } else {
            $this->Identificador = $identificador;
        }
        return $this;
    }
    /**
     * Get Chave value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getChave()
    {
        return isset($this->Chave) ? $this->Chave : null;
    }
    /**
     * Set Chave value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $chave
     * @return \StructType\ConsultaTransferencia
     */
    public function setChave($chave = null)
    {
        // validation for constraint: string
        if (!is_null($chave) && !is_string($chave)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($chave, true), gettype($chave)), __LINE__);
        }
        if (is_null($chave) || (is_array($chave) && empty($chave))) {
            unset($this->Chave);
        } else {
            $this->Chave = $chave;
        }
        return $this;
    }
    /**
     * Get trocaCheque value
     * @return bool|null
     */
    public function getTrocaCheque()
    {
        return $this->trocaCheque;
    }
    /**
     * Set trocaCheque value
     * @param bool $trocaCheque
     * @return \StructType\ConsultaTransferencia
     */
    public function setTrocaCheque($trocaCheque = null)
    {
        // validation for constraint: boolean
        if (!is_null($trocaCheque) && !is_bool($trocaCheque)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($trocaCheque, true), gettype($trocaCheque)), __LINE__);
        }
        $this->trocaCheque = $trocaCheque;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\ConsultaTransferencia
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
