<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for PagaTransferencia StructType
 * @subpackage Structs
 */
class PagaTransferencia extends AbstractStructBase
{
    /**
     * The DadosConsulta
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\Transferencia
     */
    public $DadosConsulta;
    /**
     * The nsuDoCliente
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $nsuDoCliente;
    /**
     * The Chave
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Chave;
    /**
     * The PagarDuplicado
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var bool
     */
    public $PagarDuplicado;
    /**
     * Constructor method for PagaTransferencia
     * @uses PagaTransferencia::setDadosConsulta()
     * @uses PagaTransferencia::setNsuDoCliente()
     * @uses PagaTransferencia::setChave()
     * @uses PagaTransferencia::setPagarDuplicado()
     * @param \StructType\Transferencia $dadosConsulta
     * @param string $nsuDoCliente
     * @param string $chave
     * @param bool $pagarDuplicado
     */
    public function __construct(\StructType\Transferencia $dadosConsulta = null, $nsuDoCliente = null, $chave = null, $pagarDuplicado = null)
    {
        $this
            ->setDadosConsulta($dadosConsulta)
            ->setNsuDoCliente($nsuDoCliente)
            ->setChave($chave)
            ->setPagarDuplicado($pagarDuplicado);
    }
    /**
     * Get DadosConsulta value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\Transferencia|null
     */
    public function getDadosConsulta()
    {
        return isset($this->DadosConsulta) ? $this->DadosConsulta : null;
    }
    /**
     * Set DadosConsulta value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\Transferencia $dadosConsulta
     * @return \StructType\PagaTransferencia
     */
    public function setDadosConsulta(\StructType\Transferencia $dadosConsulta = null)
    {
        if (is_null($dadosConsulta) || (is_array($dadosConsulta) && empty($dadosConsulta))) {
            unset($this->DadosConsulta);
        } else {
            $this->DadosConsulta = $dadosConsulta;
        }
        return $this;
    }
    /**
     * Get nsuDoCliente value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getNsuDoCliente()
    {
        return isset($this->nsuDoCliente) ? $this->nsuDoCliente : null;
    }
    /**
     * Set nsuDoCliente value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $nsuDoCliente
     * @return \StructType\PagaTransferencia
     */
    public function setNsuDoCliente($nsuDoCliente = null)
    {
        // validation for constraint: string
        if (!is_null($nsuDoCliente) && !is_string($nsuDoCliente)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($nsuDoCliente, true), gettype($nsuDoCliente)), __LINE__);
        }
        if (is_null($nsuDoCliente) || (is_array($nsuDoCliente) && empty($nsuDoCliente))) {
            unset($this->nsuDoCliente);
        } else {
            $this->nsuDoCliente = $nsuDoCliente;
        }
        return $this;
    }
    /**
     * Get Chave value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getChave()
    {
        return isset($this->Chave) ? $this->Chave : null;
    }
    /**
     * Set Chave value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $chave
     * @return \StructType\PagaTransferencia
     */
    public function setChave($chave = null)
    {
        // validation for constraint: string
        if (!is_null($chave) && !is_string($chave)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($chave, true), gettype($chave)), __LINE__);
        }
        if (is_null($chave) || (is_array($chave) && empty($chave))) {
            unset($this->Chave);
        } else {
            $this->Chave = $chave;
        }
        return $this;
    }
    /**
     * Get PagarDuplicado value
     * @return bool|null
     */
    public function getPagarDuplicado()
    {
        return $this->PagarDuplicado;
    }
    /**
     * Set PagarDuplicado value
     * @param bool $pagarDuplicado
     * @return \StructType\PagaTransferencia
     */
    public function setPagarDuplicado($pagarDuplicado = null)
    {
        // validation for constraint: boolean
        if (!is_null($pagarDuplicado) && !is_bool($pagarDuplicado)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($pagarDuplicado, true), gettype($pagarDuplicado)), __LINE__);
        }
        $this->PagarDuplicado = $pagarDuplicado;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\PagaTransferencia
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
