<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ReciboImprimirDTO StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ReciboImprimirDTO
 * @subpackage Structs
 */
class ReciboImprimirDTO extends AbstractStructBase
{
    /**
     * The Codigo
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $Codigo;
    /**
     * The Tipo
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $Tipo;
    /**
     * Constructor method for ReciboImprimirDTO
     * @uses ReciboImprimirDTO::setCodigo()
     * @uses ReciboImprimirDTO::setTipo()
     * @param int $codigo
     * @param string $tipo
     */
    public function __construct($codigo = null, $tipo = null)
    {
        $this
            ->setCodigo($codigo)
            ->setTipo($tipo);
    }
    /**
     * Get Codigo value
     * @return int|null
     */
    public function getCodigo()
    {
        return $this->Codigo;
    }
    /**
     * Set Codigo value
     * @param int $codigo
     * @return \StructType\ReciboImprimirDTO
     */
    public function setCodigo($codigo = null)
    {
        // validation for constraint: int
        if (!is_null($codigo) && !(is_int($codigo) || ctype_digit($codigo))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($codigo, true), gettype($codigo)), __LINE__);
        }
        $this->Codigo = $codigo;
        return $this;
    }
    /**
     * Get Tipo value
     * @return string|null
     */
    public function getTipo()
    {
        return $this->Tipo;
    }
    /**
     * Set Tipo value
     * @uses \EnumType\TipoReciboImprimirDTO::valueIsValid()
     * @uses \EnumType\TipoReciboImprimirDTO::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $tipo
     * @return \StructType\ReciboImprimirDTO
     */
    public function setTipo($tipo = null)
    {
        // validation for constraint: enumeration
        if (!\EnumType\TipoReciboImprimirDTO::valueIsValid($tipo)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \EnumType\TipoReciboImprimirDTO', is_array($tipo) ? implode(', ', $tipo) : var_export($tipo, true), implode(', ', \EnumType\TipoReciboImprimirDTO::getValidValues())), __LINE__);
        }
        $this->Tipo = $tipo;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\ReciboImprimirDTO
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
