<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for URLRecibos StructType
 * @subpackage Structs
 */
class URLRecibos extends AbstractStructBase
{
    /**
     * The recibosDTO
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfReciboImprimirDTO
     */
    public $recibosDTO;
    /**
     * The Chave
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Chave;
    /**
     * Constructor method for URLRecibos
     * @uses URLRecibos::setRecibosDTO()
     * @uses URLRecibos::setChave()
     * @param \ArrayType\ArrayOfReciboImprimirDTO $recibosDTO
     * @param string $chave
     */
    public function __construct(\ArrayType\ArrayOfReciboImprimirDTO $recibosDTO = null, $chave = null)
    {
        $this
            ->setRecibosDTO($recibosDTO)
            ->setChave($chave);
    }
    /**
     * Get recibosDTO value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfReciboImprimirDTO|null
     */
    public function getRecibosDTO()
    {
        return isset($this->recibosDTO) ? $this->recibosDTO : null;
    }
    /**
     * Set recibosDTO value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfReciboImprimirDTO $recibosDTO
     * @return \StructType\URLRecibos
     */
    public function setRecibosDTO(\ArrayType\ArrayOfReciboImprimirDTO $recibosDTO = null)
    {
        if (is_null($recibosDTO) || (is_array($recibosDTO) && empty($recibosDTO))) {
            unset($this->recibosDTO);
        } else {
            $this->recibosDTO = $recibosDTO;
        }
        return $this;
    }
    /**
     * Get Chave value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getChave()
    {
        return isset($this->Chave) ? $this->Chave : null;
    }
    /**
     * Set Chave value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $chave
     * @return \StructType\URLRecibos
     */
    public function setChave($chave = null)
    {
        // validation for constraint: string
        if (!is_null($chave) && !is_string($chave)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($chave, true), gettype($chave)), __LINE__);
        }
        if (is_null($chave) || (is_array($chave) && empty($chave))) {
            unset($this->Chave);
        } else {
            $this->Chave = $chave;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\URLRecibos
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
